/***********************************************************************/
/* Programa GNU que activa y desactiva la linea RTS en DOS             */
/* Autor: Jaime Jose Gavin Sierra    Alias: JJ   Programa: RTS v1.0    */
/* Correo: jaimejj@mixmail.com                                         */
/* Web: http://www.lanzadera.com/ensamblador                           */
/* Asturias (Espaa)                                                   */
/* Opciones: ON, OFF, NULL                                             */
/* Hay dos binarios:                                                   */
/*  rts.exe  (compilado con DJGPP en 32 bits y requiere CWSDPMI)       */
/*  rts8086  (compilado con tc 3.1, que funciona en un 8086)           */
/***********************************************************************/

#define boolean int
#define TRUE 1
#define FALSE 0

short int i;
boolean activar = FALSE;
boolean visualizar = TRUE;
short int puerto_COM = 0x2F8+4;  //Por defecto el COM2

void MostrarMenu(void);
void MostrarError(void);

int main(int argc, char **argv){

 for (i=1;i<argc;i++){
  if (strcmp(argv[i],"COM1")==0) puerto_COM = 0x3F8+4;
  if (strcmp(argv[i],"COM2")==0) puerto_COM = 0x2F8+4;
  if (strcmp(argv[i],"COM3")==0) puerto_COM = 0x3E8+4;
  if (strcmp(argv[i],"COM4")==0) puerto_COM = 0x2E8+4;
  if (strcmp(argv[i],"ON")==0) activar = TRUE;
  if (strcmp(argv[i],"OFF")==0) activar = FALSE;
  if (strcmp(argv[i],"NULL")==0) visualizar = FALSE;
 }

 if (visualizar == TRUE) MostrarMenu();

 if (argc>1){

  if (activar==TRUE){
   if (visualizar == TRUE) printf("\n Accion: RTS ON\n");
   outportb (puerto_COM,0xB);
  }
  else{
   if (visualizar == TRUE) printf("\n Accion: RTS OFF\n");
   outportb (puerto_COM,0xFF);
  }

 }
 return (0);
}

/*********************************/
void MostrarMenu(void){
 printf ("Programa RTS v1.0      Autor: JJ\n");
 printf ("---------------------------------\n");
 printf (" winrts [opciones]\n\n");
 printf (" opciones --> ON   (activa la linea RTS)\n");
 printf ("          --> OFF  (desctiva la linea RTS)\n");
 printf ("          --> NULL (no muestra por pantalla)\n");
 printf ("          --> COM1 (puerto COM1)\n");
 printf ("          --> COM2 (puerto COM2)\n");
 printf ("          --> COM3 (puerto COM3)\n");
 printf ("          --> COM4 (puerto COM4)\n\n");
 printf (" ejemplo: rts COM1 ON\n");
}

/*********************************/
void MostrarError(void){
 if (visualizar==TRUE)
  printf ("\nError en la apertura del puerto serie\n");
 exit(-1);
}


/*int main (void){
 //El valor 0xB nos funciona tambien en el puerto serie
 anterior = inportb(0x3F8+4);
// outportb(0x3F8+4,0xB); //Vale 0xB y 0x3
 outportb (0x3F8+4,0x0B);
 printf ("Linea RTS activa\nPulse cualquier tecla\n");
  while (!kbhit());
// outportb(0x3F8+4,anterior);
 outportb (0x3F8+4,0xFF);
 printf ("Linea RTS desactivada\n");
 return (0);
}*/
