/***********************************************************************/
/* Programa GNU que activa y desactiva la linea RTS en WIN32           */
/* Autor: Jaime Jose Gavin Sierra    Alias: JJ   Programa: WINRTS v1.0 */
/* Correo: jaimejj@mixmail.com                                         */
/* Web: http://www.lanzadera.com/ensamblador                           */
/* Asturias (Espaa)                                                   */
/* Opciones: ON, OFF, NULL                                             */
/***********************************************************************/
#include <windows.h>
#include <string.h>

#define boolean int

short int i;
boolean activar = FALSE;
boolean visualizar = TRUE;
boolean puerto_COM1 = FALSE;
boolean puerto_COM2 = FALSE;
boolean puerto_COM3 = FALSE;
boolean puerto_COM4 = FALSE;

void MostrarMenu(void);
void MostrarError(void);

int main(int argc, char **argv){
 HANDLE hcom;

// for (i=1;i<argc;i++)  //Convierte en mayusculas pero accedo a datos del SO
//  strupr(argv[i]);

 for (i=1;i<argc;i++){
  if (strcmp(argv[i],"COM1")==0) puerto_COM1 = TRUE;
  if (strcmp(argv[i],"COM2")==0) puerto_COM2 = TRUE;
  if (strcmp(argv[i],"COM3")==0) puerto_COM3 = TRUE;
  if (strcmp(argv[i],"COM4")==0) puerto_COM4 = TRUE;
  if (strcmp(argv[i],"ON")==0) activar = TRUE;
  if (strcmp(argv[i],"OFF")==0) activar = FALSE;
  if (strcmp(argv[i],"NULL")==0) visualizar = FALSE;
 }

 if (visualizar == TRUE) MostrarMenu();

 if (argc>1){
  if (puerto_COM1==TRUE){
   if (visualizar == TRUE) printf("\n Puerto: COM1\n");
   hcom = CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   if (hcom==INVALID_HANDLE_VALUE) MostrarError();
  }
  else
   if (puerto_COM2==TRUE){
    if (visualizar == TRUE) printf("\n Puerto: COM2\n");
    hcom = CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
    if (hcom==INVALID_HANDLE_VALUE) MostrarError();
   }
   else
    if (puerto_COM3==TRUE){
     if (visualizar == TRUE) printf("\n Puerto: COM3\n");
     hcom = CreateFile("COM3",GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
     if (hcom==INVALID_HANDLE_VALUE) MostrarError();
    }
    else
     if (puerto_COM4==TRUE){
      if (visualizar == TRUE) printf("\n Puerto: COM4\n");
      hcom = CreateFile("COM4",GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      if (hcom==INVALID_HANDLE_VALUE) MostrarError();
     }

  if (activar==TRUE){
   if (visualizar == TRUE) printf("\n Accion: RTS ON\n");
   EscapeCommFunction(hcom,SETRTS);
  }
  else{
   if (visualizar == TRUE) printf("\n Accion: RTS OFF\n");
   EscapeCommFunction(hcom,CLRRTS);
  }
  CloseHandle(hcom);
 }
 return (0);
}

/*********************************/
void MostrarMenu(void){
 printf ("Programa RTS v1.0      Autor: JJ\n");
 printf ("---------------------------------\n");
 printf (" winrts [opciones]\n\n");
 printf (" opciones --> ON   (activa la linea RTS)\n");
 printf ("          --> OFF  (desctiva la linea RTS)\n");
 printf ("          --> NULL (no muestra por pantalla)\n");
 printf ("          --> COM1 (puerto COM1)\n");
 printf ("          --> COM2 (puerto COM2)\n");
 printf ("          --> COM3 (puerto COM3)\n");
 printf ("          --> COM4 (puerto COM4)\n\n");
 printf (" ejemplo: winrts COM1 ON\n");
}

/*********************************/
void MostrarError(void){
 if (visualizar==TRUE)
  printf ("\nError en la apertura del puerto serie\n");
 exit(-1);
}
